configure.ac 6.55 KB
Newer Older
1
AC_PREREQ([2.64])
2

3
m4_define([wayland_major_version],  [1])
4
m4_define([wayland_minor_version], [16])
5
m4_define([wayland_micro_version],  [90])
6 7 8
m4_define([wayland_version],
          [wayland_major_version.wayland_minor_version.wayland_micro_version])

9
AC_INIT([wayland],
10
        [wayland_version],
11
	[https://gitlab.freedesktop.org/wayland/wayland/issues/],
12
        [wayland],
13
        [https://wayland.freedesktop.org/])
14

15 16 17 18 19
AC_SUBST([WAYLAND_VERSION_MAJOR], [wayland_major_version])
AC_SUBST([WAYLAND_VERSION_MINOR], [wayland_minor_version])
AC_SUBST([WAYLAND_VERSION_MICRO], [wayland_micro_version])
AC_SUBST([WAYLAND_VERSION], [wayland_version])

20
AC_CONFIG_HEADERS([config.h])
21 22
AC_CONFIG_MACRO_DIR([m4])

23
AM_INIT_AUTOMAKE([1.11 foreign no-dist-gzip dist-xz subdir-objects])
24

Kristian H. Kristensen's avatar
Kristian H. Kristensen committed
25
AM_SILENT_RULES([yes])
26

27 28
# Check for programs
AC_PROG_CC
29
AC_PROG_CXX
30
AC_PROG_GREP
31
AM_PROG_AS
32
AC_PROG_NM
33 34 35 36 37 38 39 40 41 42 43

# check if we have C++ compiler. This is hacky workaround,
# for a reason why it is this way see
# http://lists.gnu.org/archive/html/bug-autoconf/2010-05/msg00001.html
have_cpp_compiler=yes

if ! which "$CXX" &>/dev/null; then
	have_cpp_compiler=no
fi

AM_CONDITIONAL(ENABLE_CPP_TEST, test "x$have_cpp_compiler" = "xyes")
44 45 46

# Initialize libtool
LT_PREREQ([2.2])
47
LT_INIT([disable-static])
48

49 50
PKG_PROG_PKG_CONFIG()

51 52 53 54 55 56 57 58 59
AC_ARG_ENABLE([fatal-warnings],
	      AC_HELP_STRING([--enable-fatal-warnings],
			     [Build with -Werror]),
	      [enable_fatal_warnings=$enableval],
	      [enable_fatal_warnings=no])
AS_IF([test x"$enable_fatal_warnings" != "xno"], [
      WERROR_CFLAGS="-Werror"
])

60
if test "x$GCC" = "xyes"; then
61
	GCC_CFLAGS="$WERROR_CFLAGS -Wall -Wextra -Wno-unused-parameter -g -Wstrict-prototypes -Wmissing-prototypes -fvisibility=hidden"
62 63 64
fi
AC_SUBST(GCC_CFLAGS)

65 66
AC_CHECK_HEADERS([sys/prctl.h])
AC_CHECK_FUNCS([accept4 mkostemp posix_fallocate prctl])
67

68 69 70 71 72
AC_ARG_ENABLE([libraries],
	      [AC_HELP_STRING([--disable-libraries],
			      [Disable compilation of wayland libraries])],
	      [],
	      [enable_libraries=yes])
73

74 75 76
AC_ARG_WITH([host-scanner],
              [AC_HELP_STRING([--with-host-scanner],
                              [Use installed wayland-scanner from host PATH during build])],
77
              [],
78
              [with_host_scanner=no])
79

80 81 82 83 84 85
AC_ARG_ENABLE([documentation],
	      [AC_HELP_STRING([--disable-documentation],
		              [Disable building the documentation])],
	      [],
	      [enable_documentation=yes])

86 87 88 89
AC_ARG_ENABLE([dtd-validation],
	      [AC_HELP_STRING([--disable-dtd-validation],
			      [Disable DTD validation of the protocol])],
	      [],
90
	      [enable_dtd_validation=yes])
91

92
AM_CONDITIONAL(USE_HOST_SCANNER, test "x$with_host_scanner" = xyes)
93

94 95
AM_CONDITIONAL(ENABLE_LIBRARIES, test "x$enable_libraries" = xyes)

96 97 98 99 100
AC_ARG_WITH(icondir, [  --with-icondir=<dir>    Look for cursor icons here],
		     [  ICONDIR=$withval],
		     [  ICONDIR=${datadir}/icons])
AC_SUBST([ICONDIR])

101
if test "x$enable_libraries" = "xyes"; then
102
	PKG_CHECK_MODULES(FFI, [libffi])
103 104 105 106 107 108 109 110 111 112 113
	AC_CHECK_DECL(SFD_CLOEXEC,[],
		      [AC_MSG_ERROR("SFD_CLOEXEC is needed to compile wayland libraries")],
		      [[#include <sys/signalfd.h>]])
	AC_CHECK_DECL(TFD_CLOEXEC,[],
		      [AC_MSG_ERROR("TFD_CLOEXEC is needed to compile wayland libraries")],
		      [[#include <sys/timerfd.h>]])
	AC_CHECK_DECL(CLOCK_MONOTONIC,[],
		      [AC_MSG_ERROR("CLOCK_MONOTONIC is needed to compile wayland libraries")],
		      [[#include <time.h>]])
fi

114
PKG_CHECK_MODULES(EXPAT, [expat])
115

116 117
AM_CONDITIONAL([DTD_VALIDATION], [test "x$enable_dtd_validation" = "xyes"])
if test "x$enable_dtd_validation" = "xyes"; then
118 119 120 121 122
	PKG_CHECK_MODULES(LIBXML, [libxml-2.0])
	AC_DEFINE(HAVE_LIBXML, 1, [libxml-2.0 is available])
	AC_CONFIG_LINKS([src/wayland.dtd.embed:protocol/wayland.dtd])
fi

123
AC_PATH_PROG(XSLTPROC, xsltproc)
124
AM_CONDITIONAL([HAVE_XSLTPROC], [test "x$XSLTPROC" != "x"])
125

126 127 128 129 130 131 132 133 134 135 136 137 138 139
AC_MSG_CHECKING([for docbook manpages stylesheet])
MANPAGES_STYLESHEET=http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl
AC_PATH_PROGS_FEATURE_CHECK([XSLTPROC_TMP], [xsltproc],
			    AS_IF([`"$ac_path_XSLTPROC_TMP" --nonet "$MANPAGES_STYLESHEET" > /dev/null 2>&1`],
				  [HAVE_MANPAGES_STYLESHEET=yes]))
if test "x$HAVE_MANPAGES_STYLESHEET" = "xyes"; then
	AM_CONDITIONAL([HAVE_MANPAGES_STYLESHEET], true)
	AC_SUBST(MANPAGES_STYLESHEET)
	AC_MSG_RESULT([yes])
else
	AM_CONDITIONAL([HAVE_MANPAGES_STYLESHEET], false)
	AC_MSG_RESULT([no])
fi

140
AM_CONDITIONAL(BUILD_DOCS, [test x$enable_documentation = xyes])
141
if test "x$enable_documentation" = "xyes"; then
142 143 144 145 146 147
	AC_PATH_PROG(DOXYGEN, doxygen)

	if test "x$DOXYGEN" = "x"; then
		AC_MSG_ERROR([Documentation build requested but doxygen not found. Install doxygen or disable the documentation using --disable-documentation])
	fi

148 149 150 151 152 153 154 155
	AC_MSG_CHECKING([for compatible doxygen version])
	doxygen_version=`$DOXYGEN --version`
	AS_VERSION_COMPARE([$doxygen_version], [1.6.0],
	                   [AC_MSG_RESULT([no])
	                    AC_MSG_ERROR([Doxygen $doxygen_version too old. Doxygen 1.6+ required for documentation build. Install required doxygen version or disable the documentation using --disable-documentation])],
	                   [AC_MSG_RESULT([yes])],
	                   [AC_MSG_RESULT([yes])])

156
	AC_PATH_PROG(XMLTO, xmlto)
157

158 159
	if test "x$XMLTO" = "x"; then
		AC_MSG_ERROR([Documentation build requested but xmlto not found. Install xmlto or disable the documentation using --disable-documentation])
160 161
	fi

162 163 164 165 166
	AC_PATH_PROG(DOT, dot)
	if test "x$DOT" = "x"; then
		AC_MSG_ERROR([Documentation build requested but graphviz's dot not found. Install graphviz or disable the documentation using --disable-documentation])
	fi
	AC_MSG_CHECKING([for compatible dot version])
167
	dot_version=`$DOT -V 2>&1|$GREP -o ['[0-9]*\.[0-9]*\.[0-9]*']`
168 169 170 171 172 173
	AS_VERSION_COMPARE([$dot_version], [2.26.0],
	                   [AC_MSG_RESULT([no])
	                    AC_MSG_ERROR([Graphviz dot $dot_version too old. Graphviz 2.26+ required for documentation build. Install required graphviz version or disable the documentation using --disable-documentation])],
	                   [AC_MSG_RESULT([yes])],
	                   [AC_MSG_RESULT([yes])])

174 175 176 177
	AC_CONFIG_FILES([
	doc/doxygen/wayland.doxygen
	])

178
fi
179
AM_CONDITIONAL([HAVE_XMLTO], [test "x$XMLTO" != "x"])
180

181
AC_CONFIG_FILES([Makefile
182
		 cursor/wayland-cursor.pc
183
		 cursor/wayland-cursor-uninstalled.pc
184
		 doc/Makefile
185
		 doc/publican/Makefile
186
		 doc/doxygen/Makefile
187
		 doc/man/Makefile
188 189
		 egl/wayland-egl.pc
		 egl/wayland-egl-backend.pc
190 191
		 src/wayland-server-uninstalled.pc
		 src/wayland-client-uninstalled.pc
192
		 src/wayland-scanner-uninstalled.pc
193
		 src/wayland-server.pc
194
		 src/wayland-client.pc
195
		 src/wayland-scanner.pc
196
		 src/wayland-version.h])
197
AC_OUTPUT